const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const warehouses = sequelize.define(
    'warehouses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"raw",


"wip",


"finished",


"spares",


"quarantine"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  warehouses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.warehouses.hasMany(db.locations, {
      as: 'locations_warehouse',
      foreignKey: {
          name: 'warehouseId',
      },
      constraints: false,
    });









    db.warehouses.hasMany(db.receipts, {
      as: 'receipts_warehouse',
      foreignKey: {
          name: 'warehouseId',
      },
      constraints: false,
    });
























//end loop



    db.warehouses.belongsTo(db.plants, {
      as: 'plant',
      foreignKey: {
        name: 'plantId',
      },
      constraints: false,
    });




    db.warehouses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.warehouses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return warehouses;
};


